% Euler's method for solving IVP
% y'(t) = f(t,y(t)), y(a) = alpha 
% t defined on [a,b]

f = @(t,y) (y - t.^2 + 1);
%f = @(t,y) ((2./t).*y + (t.^2).*exp(t));


a = 0;
b = 2;
alpha = 1/2; % y(a) = alpha

h = 0.001;

N = round((b-a)/h)

t = [a:h:b];
w = zeros(N+1,1);

t(1) =a;

w(1) = alpha;

for i=2:N+1 %i=1:N
    %w(i) = w(i-1) + h*f(t(i-1),w(i-1));
    w(i) = myround(w(i-1) + h*f(t(i-1),w(i-1)),4);
    t(i) = a+(i-1)*h;
    disp(['it # = ' num2str(i) ' %% ' 'w = ' num2str(w(i)) ] )
end
%format long g
disp('****************************************************')
disp(' t              w')
disp([num2str([t', w],8)])
disp('****************************************************')


%y = @(t) ((t.^2).*(exp(t)-exp(1)));
y = @(t) ((t+1).^2 -0.5*exp(t));

M = 0.5*exp(2)-2;
delta = 0.5*1e-4;

err = abs(y(2)-w(N+1)) 

h_lb = sqrt(2*delta/M)